%global commit bc56c6882269fb14e36bc7bd6582c19be6114c06
%global shortcommit %(c=%{commit}; echo ${c:0:7})
%global snapshot 20130128git%{shortcommit}
Name:           sfact
Version:        0.0
Release:        13.%{snapshot}%{?dist}
Summary:        Converts 3D model into G-Code for RepRap
License:        AGPLv3
Group:          Applications/Engineering
URL:            http://www.reprapfordummies.net/
Source0:        https://github.com/ahmetcemturan/SFACT/archive/%{commit}/%{name}-%{version}-%{shortcommit}.tar.gz
Source1:        %{name}.desktop
Source2:        %{name}
Source3:        %{name}-craft
Patch0:         %{name}-remove-tkinter-warning.patch
Patch1:         %{name}-setting-dir.patch
Patch2:         %{name}-empty-extrusion-profile.patch
Patch3:         %{name}-empty-winding-profile.patch
Patch4:         %{name}-empty-cutting-profile.patch
Patch5:         %{name}-empty-milling-profile.patch
# Remove "Slice with PyPy" checkbox,
# it just works (i.e. it uses PyPy on supported arches)
Patch6:         %{name}-no-pypy-switch.patch

# Cannot be noarch, as pypy_sitelib differs on arches
# Aslo, on aarch64, no pypy, so this will get nasty
# BuildArch:      noarch
%global debug_package %{nil}

%ifarch aarch64 s390
# does not support pypy

BuildRequires:  python2-devel
Requires:       python2
Requires:       tkinter

%global pypy 0
%global interpreter %{__python2}
%global sitelib %{python2_sitelib}

%else # arch

BuildRequires:  pypy-devel
# Need to require exact pypy version, because the directory differs
Requires:       pypy = %(echo %{pypy_sitelib} | sed -e s@%{_libdir}/pypy-@@ -e s@/site-packages@@)

# Turn off the brp-python-bytecompile postprocessing script
# We manually invoke it later on, using pypy
%global __os_install_post \
  %(echo '%{__os_install_post}' | sed -e 's!/usr/lib[^[:space:]]*/brp-python-bytecompile[[:space:]].*$!!g')


%global pypy 1
%global interpreter %{__pypy}
%global sitelib %{pypy_sitelib}

%endif # arch

BuildRequires:  desktop-file-utils


%description
SFACT is the new Skeinforge, it is a tool chain composed of Python scripts
that converts your 3D model into G-Code instructions for RepRap.

%package        doc
Requires:       %{name} = %{version}-%{release}
Summary:        Documentation for %{name}
BuildArch:      noarch

%description    doc
SFACT is the new Skeinforge, it is a tool chain composed of Python scripts
that converts your 3D model into G-Code instructions for RepRap.
This is the documentation.

%prep
%setup -qn SFACT-%{commit}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1

chmod +x sfact.py
chmod -x fabmetheus_utilities/settings.py

# Removing stupid useless files
rm -rf skeinforge_application/*.sh skeinforge_application/*.stl skFrontend.py *.sh

# Removing shebangs
cd skeinforge_application/skeinforge_plugins/craft_plugins/
for FILE in  alteration.py bottom.py dimension.py fill.py inset.py limit.py preface.py scale.py widen.py ../../profiles/dimension2.py ../../skeinforge.py ../../../%{name}.py; do
  awk 'FNR>1' $FILE > $FILE.nobang && mv -f $FILE.nobang $FILE
  chmod -x $FILE
done
cd -

cd fabmetheus_utilities/miscellaneous/fabricate/
for FILE in example.py send.py RepRapArduinoSerialSender.py; do
  awk 'FNR>1' $FILE > $FILE.nobang && mv -f $FILE.nobang $FILE
done
chmod +x frank_davies/t.sh
cd -

cp -a %{SOURCE2} %{SOURCE3} .
sed -i -e 's@INTERPRETER@%{interpreter}@' -e 's@SITELIB@%{sitelib}@' %{name}{,-craft}

%build

%install
mkdir -p %{buildroot}%{sitelib}/%{name}
mkdir -p %{buildroot}%{_bindir}
cp -ar [fs_]* %{buildroot}%{sitelib}/%{name}
desktop-file-install --dir=%{buildroot}%{_datadir}/applications %{SOURCE1} # desktop file
cp -a %{name}{,-craft} %{buildroot}%{_bindir} # launchers
rm %{buildroot}%{sitelib}/%{name}/%{name}{,-craft}

%if 0%{?pypy}
# Bytecompile it by running it
echo "Ignore the TclError and warning"
pypy %{buildroot}%{pypy_sitelib}/%{name}/%{name}.py || :
echo "Ignore the TclError and warning"
%endif # pypy

%files
%doc SFACT?Readme.txt COPYING
%{sitelib}/%{name}
%{_datadir}/applications/%{name}.desktop
%{_bindir}/%{name}*

%files      doc
%doc documentation

%changelog
* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.0-13.20130128gitbc56c68
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Tue Nov 15 2016 Miro Hrončok <mhroncok@redhat.com> - 0.0-12.20130128gitbc56c68
- Rebuilt for new pypy, arch condition updated according to pypy

* Sun Nov 13 2016 Peter Robinson <pbrobinson@fedoraproject.org> 0.0-11.20130128gitbc56c68
- rebuild (Power64)

* Tue Sep 20 2016 Miro Hrončok <mhroncok@redhat.com> - 0.0-10.20130128gitbc56c68
- Make it pure pypy or pure python2 depending on the arch

* Tue Jul 19 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.0-9.20130128gitbc56c68
- https://fedoraproject.org/wiki/Changes/Automatic_Provides_for_Python_RPM_Packages

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.0-8.20130128gitbc56c68
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Fri Jun 19 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.0-7.20130128gitbc56c68
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.0-6.20130128gitbc56c68
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Sun Aug 25 2013 Miro Hrončok <mhroncok@redhat.com> - 0.0-5.20130128gitbc56c68
- Remove the patch to remove help button
- Added patch to remove Tkinter warning

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.0-4.20130128gitbc56c68
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Fri Feb 01 2013 Miro Hrončok <mhroncok@redhat.com> - 0.0-3.20130128gitbc56c68
- Corrected version in %%changelog
- Use exec in launchers

* Tue Jan 29 2013 Miro Hrončok <mhroncok@redhat.com> - 0.0-2.20130128gitbc56c68
- SFACT?Readme.txt instead of SFACT\ Readme.txt in %%doc to make this work in rawhide
- New commit including COPYING

* Sun Jan 27 2013 Miro Hrončok <mhroncok@redhat.com> - 0.0-1.20121114git89e1e76
- Started as a fork of skeinforge.spec
- Updated source to GitHub, SFACT has no tarballs
- Added patches from Debain
- Added patch to keep setting in HOME
